<?php

	class Rcon
	{

		var $challenge_number;
		var $connected;
		var $server_ip;
		var $server_password;
		var $server_port;
		var $socket;

		function Rcon()
		{
    
			$this->challenge_number = 0;
			$this->connected = true;
			$this->server_password = "";
			$this->server_password = 27015;
			$this->server_password = "";
		
		}

		function Connect($server_ip, $server_port, $server_password = "")
		{
    
			$this->server_ip = gethostbyname($server_ip);
			$this->server_port = $server_port;
			$this->server_password = $server_password;

			$fp = fsockopen("udp://" . $this->server_ip, $this->server_port, &$errno, &$errstr, 5);
			if($fp)
			{
				
				$this->connected = true;
				
			}
    
			else
			{
				
				$this->connected = false;
				return false;
			
			}

			$this->socket = $fp;

			return true;

		}

		function Disconnect()
		{
    
			fclose($this->socket);
			$connected = false;

		}

		function IsConnected()
		{

			return $this->connected;
		
		}

		function ServerInfo()
		{
    
			if(!$this->connected)
			{
				
				return $this->connected;
				
			}

			$status = $this->RconCommand("status");

			if(!$status || trim($status) == "Bledne haslo RCON!")
			{
			
				return $status;
				
			}

			$line = explode("\n", $status);
			$map = substr($line[3], strpos($line[3], ":") + 1);
			$players = trim(substr($line[4], strpos($line[4], ":") + 1));
			$active = explode(" ", $players);

			$result["ip"] = trim(substr($line[2], strpos($line[2], ":") + 1));
			$result["name"] = trim(substr($line[0], strpos($line[0], ":") + 1));
			$result["map"] = trim(substr($map, 0, strpos($map, "at:")));
			$result["mod"] = "CounterStrike " . trim(substr($line[1], strpos($line[1], ":") + 1));
			$result["game"] = "Halflife";
			$result["activeplayers"] = $active[0];
			$result["maxplayers"] = substr($active[2], 1);

			for($i = 1; $i <= $result["activeplayers"]; $i++)
			{
			
				$tmp = $line[$i + 6];

				if(substr_count($tmp, "#") <= 0)
				{
        
					break;
					
				}

				$begin = strpos($tmp, "\"") + 1;
				$end = strrpos($tmp, "\"");
				$result[$i]["name"] = substr($tmp, $begin, $end - $begin);
				$tmp = trim(substr($tmp, $end + 1));

				$end = strpos($tmp, " ");
				$result[$i]["id"] = substr($tmp, 0, $end);
				$tmp = trim(substr($tmp, $end));

				$end = strpos($tmp, " ");
				$result[$i]["wonid"] = substr($tmp, 0, $end);
				$tmp = trim(substr($tmp, $end));

				$end = strpos($tmp, " ");
				$result[$i]["frag"] = substr($tmp, 0, $end);
				$tmp = trim(substr($tmp, $end));

				$end = strpos($tmp, " ");
				$result[$i]["time"] = substr($tmp, 0, $end);
				$tmp = trim(substr($tmp, $end));

				$end = strpos($tmp, " ");
				$result[$i]["ping"] = substr($tmp, 0, $end);
				$tmp = trim(substr($tmp, $end));

				$tmp = trim(substr($tmp, $end));

				$result[$i]["adress"] = $tmp;

			}

			return $result;

		}


		function Info()
		{
    
	
			if(!$this->connected)
			{

				return $this->connected;
				
			}

			$command = "\xff\xff\xff\xffinfo\x00";
			$buffer = $this->Communicate($command);

			if(trim($buffer) == "")
			{
      
				$this->connected = false;
				return false;
    
			}

			$buffer = explode("\x00", $buffer);

			$result["ip"] = substr($buffer[0], 5);
			$result["name"] = $buffer[1];
			$result["map"] = $buffer[2];
			$result["mod"] = $buffer[3];
			$result["game"] = $buffer[4];
			$result["activeplayers"] = (strlen($buffer[5]) > 1)?ord($buffer[5][0]):"0";
			$result["maxplayers"] = (strlen($buffer[5]) > 1)?ord($buffer[5][1]):"0";

			return $result;

		}

		function RconCommand($command, $pagenumber = 0, $single = true)
		{
    
			if(!$this->connected)
			{
				
				return $this->connected;
				
			}

			if($this->challenge_number == "")
			{
				
				$challenge = "\xff\xff\xff\xffchallenge rcon\n";
				$buffer = $this->Communicate($challenge);

				if(trim($buffer) == "")
				{
					
					$this->connected = false;
					return false;
				
				}

				$buffer = explode(" ", $buffer);
				$this->challenge_number = trim($buffer[2]);
			
			}

			$command = "\xff\xff\xff\xffrcon $this->challenge_number \"$this->server_password\" $command\n";

			$result = "";
			$buffer = "";
			
			while($pagenumber >= 0)
			{
    
				$buffer .= $this->Communicate($command);

				if($single == true)
				{
					
					$result = $buffer;
					
				}

				else
				{
					
					$result .= $buffer;
					
				}

				$command = "";

				$pagenumber--;

			}

			return trim($result);

		}

		function Communicate($command)
		{
    
			if(!$this->connected)
			{
     
				return $this->connected;
				
			}

			if($command != "")
			{
    
				fputs($this->socket, $command, strlen($command));
				
			}

			$buffer = fread ($this->socket, 1);
			$status = socket_get_status($this->socket);
			$buffer .= fread($this->socket, $status["unread_bytes"]);

			if(substr($buffer, 0, 4) == "\xfe\xff\xff\xff")
			{
				
				$buffer2 = fread ($this->socket, 1);
				$status = socket_get_status($this->socket);
				$buffer2 .= fread($this->socket, $status["unread_bytes"]);

				if(strlen($buffer) > strlen($buffer2))
				{
       
					$buffer = substr($buffer, 14) . substr($buffer2, 9);
					
				}
				
				else
				{
					
					$buffer = substr($buffer2, 14) . substr($buffer, 9);
					
				}

			}

			else
			{
		
				$buffer = substr($buffer, 5);
				
			}

			return $buffer;

		}

	}

?>